/*
 * I2O Configuration Browser CGI
 *
 * Copyright (c) 1999 Intel Corporation
 *
 * Originally written by Deepak Saxena(deepak.saxena@intel.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 */

/*
 * Fixes by Taneli Vhkangas
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>

#include <linux/i2o-dev.h>

#include "common.h"

int
main(void)
{
	int fd;
	char *path = getenv("PATH_INFO");
	char *query;
	char result[8192];
	struct i2o_html html;
	unsigned int len = 8192;
	struct page *p;

	p = (struct page *)malloc(sizeof(struct page));
	if (!p) {
		error_page("<H2>ERROR: Out of memory</H2><P>%s.\n", strerror(errno));
		return 1;
	}

	sscanf(path, "/%d/%x/%d", &html.iop, &html.tid, &html.page);

	if ((fd = open("/dev/i2o/ctl", O_RDONLY)) < 0)
	{
		start_page(p);
		hprintf(p, "<H2>ERROR: Could not open connection to I<SUB>2<SUB>O Platform</H2>\n", 
			html.iop);
		end_page(p);
		return 1;
	}

	html.resbuf = (void*)result;
	html.reslen = &len;

	query = getquery();
	html.qbuf = (void*)query;
	if(query) html.qlen = strlen(query)+1;
	else html.qlen = 0;

	if(!ioctl(fd, I2OHTML, &html))
	{
		start_page(p);
		result[len+1] = '\0';
		hprintf(p, "%s\n", result);
		end_page(p);
	}	
	else
	{
		/* Allow admin to check specific errors in httpd log */
		start_page(p);
		hprintf(p, "<H2>ERROR: Can't access IOP%d</H2> page %x/%d\n",
			html.iop, html.tid, html.page);
		hprintf(p, "<P>%s", strerror(errno));
		end_page(p);
		return 1;
	}

	close(fd);
	
	return 0;
}

