/*
 *   I2O Configuration utility
 *
 *   Software validation
 *
 *   (C) Copyright 1999	University of Helsinki,
 *			Department of Computer Science
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version
 *   2 of the License, or (at your option) any later version.
 *
 *   Author	Taneli Vhkangas <Taneli.Vahakangas@cs.Helsinki.FI>
 *
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>     
#include <sys/ioctl.h>
#include <ctype.h>

#include <linux/i2o-dev.h>

#include "common.h"

#define MAXLEN 8192

int main(void)
{
	int fd, iop;
	char *query, *IOP;
	struct page *p;

	query = getquery();
	IOP = decode(extract(query, "iopdestvalidate"));
	iop = atoi(IOP);

	p = (struct page *)malloc(sizeof(struct page));
	if (!p) {
		error_page("<H2>ERROR: Out of memory</H2><P>%s.", strerror(errno));
		return 1;
	}
		
	fd = open("/dev/i2o/ctl", O_RDONLY);
	if(fd < 0)
       	{
       		start_page(p);
		hprintf(p, "<H2>ERROR: Couldn't open iop%d</H2>"
			"<P>%s", iop, strerror(errno));
		end_page(p);
		return 1;
        }

	start_page(p);
	hprintf(p, "<HTML>\n");
	hprintf(p, "<HEAD><TITLE>Validate suspects modules</TITLE></HEAD>\n");
	hprintf(p, "<BODY>\n");
	hprintf(p, "<CENTER><H1>Validating suspect modules</H1></CENTER>\n");
		
	if (ioctl(fd, I2OVALIDATE, iop))
	{
		empty_page(p);
		hprintf(p, "<H2>ERROR: Can't validate</H2>\n"
				"<P>%s", strerror(errno));
		end_page(p);
		close(fd);
		return 1;
	}

	hprintf(p, "<P>All suspects modules have been validated on IOP%d", iop);
	hprintf(p, "<P><A HREF=\"" CGIPATH "IOPDetails?IOP=%d\">Back to start</A>\n", iop);
	
	hprintf(p, "</BODY>\n");
	hprintf(p, "</HTML>\n");
	end_page(p);
	
	close(fd);
	return 0;
}

